#include "../../std.h"

#include <string>

#include "../../misc/log_time.h"
#include "../../misc/escaped.h"
#include "../../misc/time_utils.h"

// HACK
extern string base_gsi_url;
extern string base_ssl_url;

// one more hack
#define WITH_NOGLOBAL
#define SOAP_FMAC3 static
#include "srm1_soapC.cpp"
#include "srm1_soapClient.cpp"
#include "srm1_soapServer.cpp"

//#define __SRM_INTERNAL_INCLUDE__
//#include "srm.h"

static int requestId = 0;

static srm11__RequestStatus* soap_error_srm11__RequestStatus(struct soap *sp,int n) {
  srm11__RequestStatus* r=soap_new_srm11__RequestStatus(sp,-1);
  if(r == NULL) return NULL;
  time_t* t = (time_t*)soap_malloc(sp,sizeof(time_t)); if(t) time(t);
  r->requestId=requestId++;
  r->type="put";
  r->state ="Failed";
  r->submitTime=t;
  r->startTime=t;
  r->finishTime=t;
  r->estTimeToStart=0;
  r->errorMessage="Method not supported"; 
  r->retryDeltaTime=0;
  r->fileStatuses=NULL;
  if(n<=0) return r;
  r->fileStatuses=soap_new_ArrayOfRequestFileStatus(sp,-1);
  if(r->fileStatuses == NULL) return r;
  r->fileStatuses->__size=n;
  r->fileStatuses->__ptr=(srm11__RequestFileStatus**)soap_malloc(sp,sizeof(srm11__RequestFileStatus*)*n);
  if(r->fileStatuses->__ptr == NULL) {
    r->fileStatuses->__size=0;
    return r;
  };
  for(int i=0;i<n;i++) {
    r->fileStatuses->__ptr[i]=soap_new_srm11__RequestFileStatus(sp,-1);
  };
  return r;
}

int srm15__put(struct soap *sp,
    ArrayOfstring*                      Src_file_names,
    ArrayOfstring*                      _arg1,
    ArrayOflong*                        _arg2,
    ArrayOfboolean*                     _arg3,
    ArrayOfstring*                      _arg4,
  struct srm15__putResponse& r) {
  int n = Src_file_names?Src_file_names->__size:0;
  r._Result=soap_error_srm11__RequestStatus(sp,n);
  if(r._Result==NULL) return SOAP_OK;
  /*
    char*   SURL                          ;//nillable
    LONG64  size                          ;
    char*   owner                         ;//nillable
    char*   group                         ;//nillable
    int     permMode                      ;
    char*   checksumType                  ;//nillable
    char*   checksumValue                 ;//nillable
    bool    isPinned                      ;
    bool    isPermanent                   ;
    bool    isCached                      ;
    char*   state                         ;//nillable
    int     fileId                        ;
    char*   TURL                          ;//nillable
    int     estSecondsToStart             ;
    char*   sourceFilename                ;//nillable
    char*   destFilename                  ;//nillable
    int     queueOrder                    ;
  */
  return SOAP_OK;
}

int srm15__get(struct soap *sp,
    ArrayOfstring*                      SURLs,
    ArrayOfstring*                      Protocols,
  struct srm15__getResponse& r) {
  int n = SURLs?SURLs->__size:0;
  r._Result=soap_error_srm11__RequestStatus(sp,n);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__copy(struct soap *sp,
    ArrayOfstring*                      _arg0,
    ArrayOfstring*                      _arg1,
    ArrayOfboolean*                     _arg2,
  struct srm15__copyResponse& r) {
  int n = _arg0?_arg0->__size:0;
  r._Result=soap_error_srm11__RequestStatus(sp,n);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__ping(struct soap *sp,
  struct srm15__pingResponse& r) {
  r._Result=true;
  return SOAP_OK;
}

int srm15__pin(struct soap *sp,
    ArrayOfstring*                      TURLs,
  struct srm15__pinResponse& r) {
  int n = TURLs?TURLs->__size:0;
  r._Result=soap_error_srm11__RequestStatus(sp,n);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__unPin(struct soap *sp,
    ArrayOfstring*                      TURLs,
    int                                 RequestId,
  struct srm15__unPinResponse& r) {
  int n = TURLs?TURLs->__size:0;
  r._Result=soap_error_srm11__RequestStatus(sp,n);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__setFileStatus(struct soap *sp,
    int                                 RequestId,
    int                                 fileId,
    char*                               state,
  struct srm15__setFileStatusResponse& r) {
  r._Result=soap_error_srm11__RequestStatus(sp,1);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__getRequestStatus(struct soap *sp,
    int                                 _arg0,
  struct srm15__getRequestStatusResponse& r) {
  r._Result=soap_error_srm11__RequestStatus(sp,1);
  if(r._Result==NULL) return SOAP_OK;
  return SOAP_OK;
}

int srm15__getFileMetaData(struct soap *sp,
    ArrayOfstring*                      _arg0,
  struct srm15__getFileMetaDataResponse& r) {


}

int srm15__mkPermanent(struct soap *sp,
    ArrayOfstring*                      _arg0,
  struct srm15__mkPermanentResponse& r) {

}

int srm15__getEstGetTime(struct soap *sp,
    ArrayOfstring*                      _arg0,
    ArrayOfstring*                      _arg1,
  struct srm15__getEstGetTimeResponse& r) {

}

int srm15__getEstPutTime(struct soap *sp,
    ArrayOfstring*                      _arg0,
    ArrayOfstring*                      _arg1,
    ArrayOflong*                        _arg2,
    ArrayOfboolean*                     _arg3,
    ArrayOfstring*                      _arg4,
  struct srm15__getEstPutTimeResponse& r) {

}

int srm15__advisoryDelete(struct soap *sp,
    ArrayOfstring*                      _arg0,
  struct srm15__advisoryDeleteResponse& r) {

}

int srm15__getProtocols(struct soap *sp,
  struct srm15__getProtocolsResponse& r
  ) {

}

