#include "httpsd.h"
#include "server/service_soap.h"

#include "jobs/jobs_soapH.h"

#include "../gridftp/fileroot.h"

class HTTP_JobControl_Handle;

class HTTP_JobControl: public HTTP_ServiceAdv {
 friend int njf__create(struct soap*,int,nj__definitionType*,__infosType&);
 friend int njf__query(struct soap*, int,nj__stateType*,     __infosType&);
 friend int njc__query(struct soap*, nj__stateType*,__infoType&);
 friend int njc__modify(struct soap*,nj__stateType*,__infoType&);
 private:
  FilePlugin *jobplugin;
  userspec_t userspec;
  string service_url;
  string job_id;
  bool job_only;
  bool extract_job_id(void);
  bool create_job(nj__definitionType& jobdef,nj__stateType& job);
  bool read_info_file(const char* name,string& content);
 public:
  HTTP_JobControl(HTTP_Connector *c,const char* uri,HTTP_JobControl_Handle& handle);
  virtual ~HTTP_JobControl(void);
  virtual HTTP_Error get(const char* uri,int &keep_alive);
  virtual HTTP_Error put(const char* uri,int &keep_alive);
  virtual HTTP_Error post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
};

HTTP_Service* jobs_service_creator(HTTP_Connector& c,const char* uri,void* arg);
bool jobs_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop);

